linux-kernel.vger.kernel.org archive mirror
 help / color / mirror / Atom feed
From: Jiri Olsa <jolsa@kernel.org>
To: Arnaldo Carvalho de Melo <acme@kernel.org>
Cc: lkml <linux-kernel@vger.kernel.org>,
	Peter Zijlstra <a.p.zijlstra@chello.nl>,
	Ingo Molnar <mingo@kernel.org>,
	Mark Rutland <mark.rutland@arm.com>,
	Namhyung Kim <namhyung@kernel.org>,
	Alexander Shishkin <alexander.shishkin@linux.intel.com>,
	Michael Petlan <mpetlan@redhat.com>,
	Ian Rogers <irogers@google.com>,
	Stephane Eranian <eranian@google.com>
Subject: [PATCH 1/9] perf tools: Add build id shell test
Date: Wed, 30 Sep 2020 19:15:04 +0200	[thread overview]
Message-ID: <20200930171512.3986425-2-jolsa@kernel.org> (raw)
In-Reply-To: <20200930171512.3986425-1-jolsa@kernel.org>

Adding test for build id cache that adds binary
with sha1 and md5 build ids and verifies it's
added properly.

The test updates build id cache with perf record
and perf buildid-cache -a.

Signed-off-by: Jiri Olsa <jolsa@kernel.org>
---
 tools/perf/Makefile.perf          | 14 +++++
 tools/perf/tests/shell/buildid.sh | 90 +++++++++++++++++++++++++++++++
 2 files changed, 104 insertions(+)
 create mode 100755 tools/perf/tests/shell/buildid.sh

diff --git a/tools/perf/Makefile.perf b/tools/perf/Makefile.perf
index 920d8afb9238..b2aeefa64e92 100644
--- a/tools/perf/Makefile.perf
+++ b/tools/perf/Makefile.perf
@@ -126,6 +126,8 @@ include ../scripts/utilities.mak
 #
 # Define NO_LIBDEBUGINFOD if you do not want support debuginfod
 #
+# Define NO_BUILDID_EX if you do not want buildid-ex-* binaries
+#
 
 # As per kernel Makefile, avoid funny character set dependencies
 unexport LC_ALL
@@ -349,6 +351,11 @@ ifndef NO_PERF_READ_VDSOX32
 PROGRAMS += $(OUTPUT)perf-read-vdsox32
 endif
 
+ifndef NO_BUILDID_EX
+PROGRAMS += $(OUTPUT)buildid-ex-sha1
+PROGRAMS += $(OUTPUT)buildid-ex-md5
+endif
+
 LIBJVMTI = libperf-jvmti.so
 
 ifndef NO_JVMTI
@@ -756,6 +763,13 @@ $(OUTPUT)perf-read-vdsox32: perf-read-vdso.c util/find-map.c
 	$(QUIET_CC)$(CC) -mx32 $(filter -static,$(LDFLAGS)) -Wall -Werror -o $@ perf-read-vdso.c
 endif
 
+ifndef NO_BUILDID_EX
+$(OUTPUT)buildid-ex-sha1:
+	$(QUIET_LINK)echo 'int main(void) { return 0; }' | $(CC) -Wl,--build-id=sha1 -o $@ -x c -
+$(OUTPUT)buildid-ex-md5:
+	$(QUIET_LINK)echo 'int main(void) { return 0; }' | $(CC) -Wl,--build-id=md5 -o $@ -x c -
+endif
+
 ifndef NO_JVMTI
 LIBJVMTI_IN := $(OUTPUT)jvmti/jvmti-in.o
 
diff --git a/tools/perf/tests/shell/buildid.sh b/tools/perf/tests/shell/buildid.sh
new file mode 100755
index 000000000000..57fcd28bc4bd
--- /dev/null
+++ b/tools/perf/tests/shell/buildid.sh
@@ -0,0 +1,90 @@
+#!/bin/sh
+# build id cache operations
+# SPDX-License-Identifier: GPL-2.0
+
+# skip if there are no test binaries
+if [ ! -x buildid-ex-sha1 -a ! -x buildid-ex-md5 ]; then
+	echo "failed: no test binaries"
+	exit 2
+fi
+
+# skip if there's no readelf
+if [ ! -x `which readelf` ]; then
+	echo "failed: no readelf, install binutils"
+	exit 2
+fi
+
+check()
+{
+	id=`readelf -n $1 2>/dev/null | grep 'Build ID' | awk '{print $3}'`
+
+	echo "build id: ${id}"
+
+	link=${build_id_dir}/.build-id/${id:0:2}/${id:2}
+	echo "link: ${link}"
+
+	if [ ! -h $link ]; then
+		echo "failed: link ${link} does not exist"
+		exit 1
+	fi
+
+	file=${build_id_dir}/.build-id/${id:0:2}/`readlink ${link}`/elf
+	echo "file: ${file}"
+
+	if [ ! -x $file ]; then
+		echo "failed: file ${file} does not exist"
+		exit 1
+	fi
+
+	diff ${file} ${1}
+	if [ $? -ne 0 ]; then
+		echo "failed: ${file} do not match"
+		exit 1
+	fi
+
+	echo "OK for ${1}"
+}
+
+test_add()
+{
+	build_id_dir=$(mktemp -d /tmp/perf.debug.XXX)
+	perf="perf --buildid-dir ${build_id_dir}"
+
+	${perf} buildid-cache -v -a ${1}
+	if [ $? -ne 0 ]; then
+		echo "failed: add ${1} to build id cache"
+		exit 1
+	fi
+
+	check ${1}
+
+	rm -rf ${build_id_dir}
+}
+
+test_record()
+{
+	data=$(mktemp /tmp/perf.data.XXX)
+	build_id_dir=$(mktemp -d /tmp/perf.debug.XXX)
+	perf="perf --buildid-dir ${build_id_dir}"
+
+	${perf} record --buildid-all -o ${data} ${1}
+	if [ $? -ne 0 ]; then
+		echo "failed: record ${1}"
+		exit 1
+	fi
+
+	check ${1}
+
+	rm -rf ${build_id_dir}
+	rm -rf ${data}
+}
+
+# add binaries manual via perf buildid-cache -a
+test_add buildid-ex-sha1
+test_add buildid-ex-md5
+
+# add binaries via perf record post processing
+test_record buildid-ex-sha1
+test_record buildid-ex-md5
+
+exit ${err}
-- 
2.26.2


  reply	other threads:[~2020-09-30 17:17 UTC|newest]

Thread overview: 33+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2020-09-30 17:15 [PATCH 0/9] perf tools: Add support for build id with different sizes Jiri Olsa
2020-09-30 17:15 ` Jiri Olsa [this message]
2020-10-01  2:00   ` [PATCH 1/9] perf tools: Add build id shell test Ian Rogers
2020-10-01  9:25     ` Jiri Olsa
2020-10-01 10:25       ` Jiri Olsa
2020-10-01 16:58         ` Ian Rogers
2020-10-01 19:05   ` [PATCHv2 " Jiri Olsa
2020-10-02 13:07     ` Namhyung Kim
2020-10-02 17:34       ` Ian Rogers
2020-10-02 19:29         ` Jiri Olsa
2020-10-06  1:37           ` Namhyung Kim
2020-10-08  9:11             ` Jiri Olsa
2020-10-08 15:22               ` Ian Rogers
2020-10-02 20:55         ` Arnaldo Carvalho de Melo
2020-10-05 15:58           ` [PATCHv3 " Jiri Olsa
2020-10-13 16:13   ` [PATCH " Arnaldo Carvalho de Melo
2020-10-13 19:15     ` Jiri Olsa
2020-09-30 17:15 ` [PATCH 2/9] perf tools: Use build_id object in dso Jiri Olsa
2020-10-01  2:01   ` Ian Rogers
2020-09-30 17:15 ` [PATCH 3/9] perf tools: Pass build_id object to filename__read_build_id Jiri Olsa
2020-10-01  5:17   ` Ian Rogers
2020-09-30 17:15 ` [PATCH 4/9] perf tools: Pass build id object to sysfs__read_build_id Jiri Olsa
2020-10-01  5:20   ` Ian Rogers
2020-09-30 17:15 ` [PATCH 5/9] perf tools: Pass build_id object to build_id__sprintf Jiri Olsa
2020-10-01  5:24   ` Ian Rogers
2020-09-30 17:15 ` [PATCH 6/9] perf tools: Pass build_id object to dso__set_build_id Jiri Olsa
2020-10-01  5:25   ` Ian Rogers
2020-09-30 17:15 ` [PATCH 7/9] perf tools: Pass build_id object to dso__build_id_equal Jiri Olsa
2020-10-01  5:25   ` Ian Rogers
2020-09-30 17:15 ` [PATCH 8/9] perf tools: Add size to struct perf_record_header_build_id Jiri Olsa
2020-10-01  5:31   ` Ian Rogers
2020-09-30 17:15 ` [PATCH 9/9] perf tools: Align buildid list output for short build ids Jiri Olsa
2020-10-01  5:35   ` Ian Rogers

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20200930171512.3986425-2-jolsa@kernel.org \
    --to=jolsa@kernel.org \
    --cc=a.p.zijlstra@chello.nl \
    --cc=acme@kernel.org \
    --cc=alexander.shishkin@linux.intel.com \
    --cc=eranian@google.com \
    --cc=irogers@google.com \
    --cc=linux-kernel@vger.kernel.org \
    --cc=mark.rutland@arm.com \
    --cc=mingo@kernel.org \
    --cc=mpetlan@redhat.com \
    --cc=namhyung@kernel.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for NNTP newsgroup(s).